<?php

class socketClass {

    var $host = 'localhost'; //主机名
	//var $host = '192.168.102.178'; //主机名
	var $port = 15002; //默认端口
    var $headerSize = 8; //头的默认大小
    var $postOutTime = 20; //发送超时时间
    var $getOutTime = 1; //获取超时时间
    var $debug = false;
    var $getSize = 24; //默认获取字节数
    var $session;
    var $cmdArr;
    var $connect = false;
    static $cmd; //命令

    public function __construct() {
        $this->cmdArr = array(
            1 => 0x5000, //获取用户名密码信息
            2 => 0x5001, //获取登陆状态
            3 => 0x5002, //登陆
            4 => 0x5003, //获取剩余试用时间
            5 => 0x5004, //获取默认共享目录
            6 => 0x5005, //设置默认共享目录
            7 => 0x5006, //获取共享目录
            8 => 0x5007, //设置共享目录
            9 => 0x5008, //获取系统路径
            10 => 0x5009, //获取传输日志
            11 => 0x500A, //获取是否有文件在传输
            12 => 0x500B, //获取是否有手机连接进来 
            13 => 0x500C, //获取系统类型
            14 => 0x500D, //弹窗
            15 => 0x500E, //注销
            16 => 0x500F, //删除日志
            17 => 0x5010, //获取局域网验证码
            18 => 0x5011, //设置局域网验证码
            19 => 0x5012, //获取MAC地址
            20 => 0x7003, //获取数据整合状态
            21 => 0x7001, //开始整合到photostation
            22 => 0x7002, //取消整合到photostation
            23 => 0x7005, //获取是否需要自动更新
            24 => 0x7004, //设置是否需要自动更新
            25 => 0x7008, //设置取消自动更新
            26 => 0x7007, //获取是否参加用户体验
            27 => 0x7006, //设置参加用户体验
            28 => 0x7009, //设置不参加用户体验
           	29 => 0x2002, //请求共享目录
           	30 => 0x2003, //获取共享目录文件
        	31 => 0x4008, //获取分享文件列表
        	32 => 0x4001, //请求分享目录
        	33 => 0x4002, //取消分享
        	34 => 0x6001, //查看付费状态
        	35 => 0x4009, //获取分享状态
        );
    }

    private function errorCode($code) {
        if ($code == '0') {
            return true;
        }

        $error['cn'] = array(
            '0x1008' => '非付费用户',
            '0x1000' => '不存在的用户',
            '0x1001' => '不正确的密码',
            '0x1002' => '用户是离线的',
            '0x1003' => '登录次数相同的用户超过极限',
            '0x1004' => '服务器繁忙的',
            '0x1005' => '未能获得登录服务器列表',
            '0x1006' => '不存在的接收端',
            '0x1007' => '未能沟通',
            '0x1009' => '未能创建文件夹',
            '0x100a' => '不正确的请求指令',
            '0x100b' => '未能删除文件',
            '0x100c' => '未能更新数据库',
            '0x100d' => '独特的标识符是空的',
            '0x100e' => '未能打开文件夹',
            '0x100f' => '未能写的',
            '0x1010' => '不需要下载文件',
            '0x1011' => '没有日志文件的上传',
            '0x1012' => '未能阅读文件',
            '0x1013' => '用户名或密码超过给定的长度',
            '0x1014' => '交通信息缓存已满',
            '0x1015' => '错误的MAC ',
            '0x1016' => '包含特殊字符',
            '0x1017' => '相同的用户登录xCloud是beyoud限制。',
            '0x1018' => '未能获得文件大小',
            '0x1019' => '未能运行',
            '0x101a' => '未能连接网络',
            '0x101b' => '空共享文件夹',
            '0x101c' => '服务器已经跑',
            '0x101d' => '未能开放数据基地',
            '0x101e' => '未能打开日志文件',
            '0x101f' => '空用户名或密码',
            '0x1020' => '未能获得mac ',
            '0x1021' => '未能获得本地IP',
            '0x1022' => '未能获得本地绑定端口',
            '0x1023' => '未能过程函数注册业务',
            '0x101f' => '空用户名或密码',
            '0x101a' => '无法连接到网络',
            '0x1008' => '非付费用户',
            '0x100c' => '未能更新数据库',
        );

        $error['tw'] = array(
            '0x1008' => '非付費用戶',
            '0x1000' => '不存在的用戶',
            '0x1001' => '不正確的密碼',
            '0x1002' => '用戶是離線的',
            '0x1003' => '登錄次數相同的用戶超過極限',
            '0x1004' => '服務器繁忙的',
            '0x1005' => '未能獲得登錄服務器列表',
            '0x1006' => '不存在的接收端',
            '0x1007' => '未能溝通',
            '0x1009' => '未能創建文件夾',
            '0x100a' => '不正確的請求指令',
            '0x100b' => '未能刪除文件',
            '0x100c' => '未能更新數據庫',
            '0x100d' => '獨特的標識符是空的',
            '0x100e' => '未能打開文件夾',
            '0x100f' => '未能寫的',
            '0x1010' => '不需要下載文件',
            '0x1011' => '沒有日誌文件的上傳',
            '0x1012' => '未能閱讀文件',
            '0x1013' => '用戶名或密碼超過給定的長度',
            '0x1014' => '交通信息緩存已滿',
            '0x1015' => '錯誤的MAC ',
            '0x1016' => '包含特殊字符',
            '0x1017' => '相同的用戶登錄xCloud是beyoud限制。',
            '0x1018' => '未能獲得文件大小',
            '0x1019' => '未能運行',
            '0x101a' => '未能連接網絡',
            '0x101b' => '空共享文件夾',
            '0x101c' => '服務器已經跑',
            '0x101d' => '未能開放數據基地',
            '0x101e' => '未能打開日誌文件',
            '0x101f' => '空用戶名或密碼',
            '0x1020' => '未能獲得mac ',
            '0x1021' => '未能獲得本地IP',
            '0x1022' => '未能獲得本地綁定端口',
            '0x1023' => '未能過程函數註冊業務',
            '0x101f' => '空用戶名或密碼',
            '0x101a' => '無法連接到網絡',
            '0x1008' => '非付費用戶',
            '0x100c' => '未能更新數據庫',
        );

        $error['en'] = array(
            '0x1008' => 'Non-paying user',
            '0x1000' => 'Nonexistent user',
            '0x1001' => 'Incorrect password',
            '0x1002' => 'User is offline',
            '0x1003' => 'The login times of the same user exceed the limit',
            '0x1004' => 'Server is busy',
            '0x1005' => 'Failed to obtain the login server list',
            '0x1006' => 'Nonexistent receiving end',
            '0x1007' => 'Failed to communicate',
            '0x1009' => 'Failed to create folder',
            '0x100A' => 'Incorrect Request Instructions',
            '0x100B' => 'Failed to delete files',
            '0x100C' => 'Failed to update data base',
            '0x100D' => 'Unique identifier is null',
            '0x100E' => 'Failed to open folder',
            '0x100F' => 'Failed to write',
            '0x1010' => 'No need to download the file',
            '0x1011' => 'No log of upload',
            '0x1012' => 'Failed to read files',
            '0x1013' => 'Username or password exceeded the given length',
            '0x1014' => 'Transit information Cache is full',
            '0x1015' => 'Wrong MAC',
            '0x1016' => 'Contain special characters',
            '0x1017' => 'That the same user login xCloud is beyoud limit.',
            '0x1018' => 'Failed to obtain the file size',
            '0x1019' => 'Failed to run',
            '0x101A' => 'Failed to connect network ',
            '0x101B' => 'Empty shared folder',
            '0x101C' => 'Server has ran',
            '0x101D' => 'Failed to open data base',
            '0x101E' => 'Failed to open log file',
            '0x101F' => 'Empty username or password',
            '0x1020' => 'Failed to obtain mac',
            '0x1021' => 'Failed to obtain local IP',
            '0x1022' => 'Failed to obtain local binding port',
            '0x1023' => 'Failed to process function of registered business',
            '0x101F' => 'Empty username or password',
            '0x101A' => 'Failed to connect to network',
            '0x1008' => 'Non-paying user',
            '0x100C' => 'Failed to update data base',
        );

        $exc = '0x';
        $code = strtoupper($code);
        $codeText = $error[lang()][$exc . $code];
        if (empty($codeText)) {
            return false;
        }
        $errorcode['code'] = $exc . $code;
        $errorcode['text'] = $codeText;
        return $errorcode;
    }

    private function socket($content, $where = false) {
        if (($socket = @socket_create(AF_INET, SOCK_STREAM, SOL_TCP)) < 0) {
            $this->debug("socket_create() failed: reason: " . socket_strerror($socket));
            return false;
        }
        @socket_set_option($socket, SOL_SOCKET, SO_RCVTIMEO, array("sec" => $this->postOutTime, "usec" => $this->getOutTime));
        $result = @socket_connect($socket, $this->host, $this->port);
        
        if ($result) {
        	$this->connect = true;
        }else{
        	$this->debug("socket_connect() failed.\nReason: ($result) " . socket_strerror($result));
        	$this->connect = false;
        	return false;
        }

        
        $len = strlen($content);

        $res = @socket_write($socket, $content, $len);
        $datas = '';
        $slen = 1;
        do {
            $r = @socket_read($socket, $this->getSize);
            if (!$r) {
                break;
            }
            $datas .= $r;
        } while ($where);
        socket_close($socket);
        return $datas;
    }

    function cmd($cmd) {
        $this->cmd = $this->cmdArr[$cmd];
    }

    private function header($size = 0) {
        $cmd = $this->cmd;
        $datasize = $this->headerSize + $size;
        $session = time();
        $session = $this->ntohl($session);
        $content = pack('n', $datasize);
        $content .= pack('n', $cmd);
        $content .= pack('I', $session);
        return $content;
    }

    /* int */

    private function ntohl($str) {
        $arr = unpack('I', pack('N', $str));
        return $arr[1];
    }

    /* short */

    private function ntohs($str) {
        return base_convert($str, '16', '10');
    }

    function login($user, $pass) {
        $this->cmd(3);
        $size = 64;
        $content = $this->header($size);
        $content .= $this->socketChar($user);
        $content .= $this->socketChar($this->getPassWord($pass));
        $post = $this->socket($content);
        if ($post) {
            $data = $this->getdata($post);
            if ($data === false) {
                return false;
            } elseif ($data == "0") {
                return true;
            } else {
                return $this->errorCode($data);
            }
        }
        return false;
    }

    function getMac() {
        $sessionname = 'Mac';
        if (isset($_SESSION[$sessionname])) {
            return $_SESSION[$sessionname];
        }
        $this->cmd(19);
        $this->getSize = 40;
        $content = $this->header();
        $data = $this->socket($content);
        $data = $this->getData($data, true);
        $data = unpack('a32', $data);
        return $data['1'];
    }

    /* common */
    function getCommonFiles(){
    	$this->cmd(29);
		$content = $this->header();
		$this->getSize = 1024;

    	$data = $this->socket($content);
    	$data = $this->getData($data, TRUE);
    	
    	return $data;
    }
    
    function getCommonFolders($path){
    	$this->cmd(30);
    	$size = 356;
    	$this->getSize = 1024;
    	$content = $this->header($size);
		$content .= pack("a1",' ');
		$content .= pack("a255",$path);
		$content .= pack("a100",'1');

    	$result = $this->socket($content);
    	$data = $this->getdata($result,true);
		
		return $data;
    }
    
    /* all share */
    function getShareFolders($flag){
    	$this->cmd(31);
		$this->postOutTime = 1;
    	$size = 70;
    	$this->getSize = 65535;
    	$content = $this->header($size);
    	$content .= pack('n',$flag);
    	$content .= pack('a32',' ');
    	$content .= pack('a36','1');
    
    	$result = $this->socket($content,true);
		$size = 402;
		$type = 'n';
		$format = '/nDirNum/nDirSumNum/a10Reserve/nmode/a10key/Ntime/a256filename/a64filenote/a32shareuser/a12szresizee';
		
		$arr = array();
        $where = 0;
        
		while ($where !== false) {
			$len = $this->headerSize;
			$str = substr($result,$where,$size);
			$data = substr($str,$len);

			$arrList = @unpack("@$where$format", $data);
			if (!$arrList) {
                break;
            }
            $arr[] = $arrList;
            $where+=$size;
        }
        
		return $arr;
    }
    
	/* request share 0:common 1:presonal*/
	function requestShare($filePath,$flag=0,$data=array()){
		$this->cmd(32);
		$this->getSize = 1048;
		
		$num = 0;
		
		$size = 428;
		if ($flag == 1){
			$num = count($data);
			$size += 32*$num;
		}
		
		/*
		for ($i=0;$i<$num;$i++){
			echo $data[$i]."+++";
		}
		exit;*/
		$content = $this->header($size);
		$content .= pack('n',$flag);
		$content .= pack('n',$num);
		$content .= pack('I',99999);
		$content .= pack('a256',$filePath);
		$content .= pack('a64',' ');
		$content .= pack('a100','1');

		if ($flag == 1){
			for($i=0; $i<$num; $i++){
				$content .= pack('a32',$data[$i]);
			}
		}
		
		$result = $this->socket($content);
		$data = $this->getdata($result,true);

		$arr = unpack('nstatus/a10key/a24reserve',$data);
		return $arr;
	}
	
	/* cancel share */
	function cancelShare($path,$mode=0,$data=array()){
		$this->cmd(33);
		$this->getSize = 58;
		/*
			personal=>data
		*/
		$size = 516;
		// common
		if ($mode == 0){
			$num = 0;
		}elseif($mode == 1){
			$num = count($data);
			$size += 32*$num;
		}

		$content = $this->header($size);
		$content .= pack('a256',$path);
		$content .= pack('n',$mode);
		$content .= pack('n',$num);

		$content .= pack('a256','1');

		if ($mode == 1){
			for($i=0; $i<$num; $i++){
				$content .= pack('a32',$data[$i]);
			}
		}

		$result = $this->socket($content);
		$result = $this->getdata($result,true);
	
		$arr = array();
		$arr = unpack("/nstatus/a56reserve",$result);

		return $arr;
	}
	
	// 获取分享状态（公有：提取码 私有 用户列表）
	function getShareStatus($path,$mode=0){
		$this->cmd(35);
		$this->postOutTime = 1;
		$size = 268;
		
		if ($mode == 0){
			$this->getSize = 32;
		}else{
			$this->getSize = 1024;
		}

		$content = $this->header($size);
		$content .= pack('n',$mode);
		$content .= pack('a256',$path);
		$content .= pack('a10','1');
	
		$data = $this->socket($content,true);
		$data = $this->getData($data,true);
		
		$arr =	unpack('a1return/a*key',$data);
		return $arr;
		//return $data;
	}
    
    function getPass() {

        $this->cmd(17);
        $this->getSize = 40;
        $content = $this->header();
        $data = $this->socket($content);
        $data = $this->getData($data, true);
        $data = @unpack('a32', $data);
        $pass = substr($data[1], 0, 6);
        
        if (strlen($pass) < 1) {
            $pass = mt_rand(1000, 9999);
            $this->setPass($pass);
        }

        return $pass;
    }

    function setPass($pass) {
        $this->cmd(18);
        $size = 32;
        $content = $this->header($size);
        $content .=pack('a32', $pass);
        $data = $this->socket($content);
        $data = $this->getData($data, true);
        $data = $this->returnType($this->errorCode($this->ntohl($data)));
        return $data;
    }

    function getType() {
        $content = $this->header();
        $data = $this->socket($content);
        $data = $this->getdata($data);
        return $this->returnType($this->errorCode($data));
    }

    function getSale() {
        $this->cmd(4);
        $content = $this->header();
        $data = $this->socket($content);
        $data = $this->getData($data, true);
        $data = @unpack('NType/NTime', $data);
        if ($this->errorCode($data['Type']) !== true) {
            return $data['Time'];
        }
        return true;
    }

    function getInfo() {
        $this->cmd(1);
        $this->getSize = 90;
        $content = $this->header();
        $data = $this->socket($content);
        $data = $this->getData($data, TRUE);
        $data = @unpack('a32User/a32Pass', $data);
        if (count($data) == 2) {
            return $data;
        }
        return false;
    }
    
    function getShareFile(){
    	$this->cmd(7);
    	$this->getSize = 1024;
    	$content = $this->header();
    	$data = $this->socket($content);
    	$data = $this->getData($data, TRUE);
    	return $data;
    }
    
    function setShareFile($data){
    	$this->cmd(8);
    	$size = strlen($data);
    	$content = $this->header($size);
    	$content .= $data;
    	$data = $this->socket($content);
    	$data = $this->getData($data, true);
    	return $data;
    }

    function getDataInterStatus(){
    	$this->cmd(20);
    	$content = $this->header();
    	$data = $this->socket($content);
    	$data = $this->getData($data,true);
    	$data = unpack('N',$data);
    	$data = $data[1];
    	return $data;
    }
 
    function startDataInter(){
    	$this->cmd(21);
    	$content = $this->header();
    	$data = $this->socket($content);
    	$data = $this->getData($data);
    	return $data;
    }
    
    function stopDataInter(){
    	$this->cmd(22);
    	$content = $this->header();
    	$data = $this->socket($content);
    	$data = $this->getData($data);
    	return $data;    	
    }
    
    // 获取自动更新状态
    function getAutoUpdate(){
    	$this->cmd(23);
    	$content = $this->header();
    	$data = $this->socket($content);
    	$data = $this->getData($data,true);
    	$data = unpack('N',$data);
    	$data = $data[1];
    	return $data;
    }
    
    // 设置需要自动更新
    function setAutoUpdateYes(){
    	$this->cmd(24);
    	//$size = strlen($data);
    	$content = $this->header();
    	$data = $this->socket($content);
    	$data = $this->getData($data,true);
    	$data = unpack('N',$data);
    	$data = $data[1];
    	return $data;
    }
    
    // 设置取消自动更新
    function setAutoUpdateNo(){
    	$this->cmd(25);
    	$content = $this->header();
    	$data = $this->socket($content);
    	$data = $this->getData($data,true);
    	$data = unpack('N',$data);
    	$data = $data[1];
    	return $data;
    }
    
    // 获取是否需要参加用户体验
    function getCountState(){
    	$this->cmd(26);
    	$content = $this->header();
    	$data = $this->socket($content);
    	$data = $this->getData($data,true);
    	$data = unpack('N',$data);
    	$data = $data[1];
    	return $data;
    }
    
    // 设置参加用户体验
    function setCountYes(){
    	$this->cmd(27);
    	$content = $this->header();
    	$data = $this->socket($content);
    	$data = $this->getData($data,true);
    	$data = unpack('N',$data);
    	$data = $data[1];
    	return $data;
    }
    
    // 设置不参加用户体验
    function setCountNo(){
    	$this->cmd(28);
    	$content = $this->header();
    	$data = $this->socket($content);
    	$data = $this->getData($data,true);
    	$data = unpack('N',$data);
    	$data = $data[1];
    	return $data;
    }
    
    function loginType() {
        $this->cmd(2);
        $type = $this->getType();
        return $type;
    }

    function logOut() {
        $this->cmd(15);
        $type = $this->getType();
        return $type;
    }

    function delLog() {
        $this->cmd(16);
        $type = $this->getType();
        return $type;
    }

    function log() {
        $this->getSize = 65535;
        $this->postOutTime = 1;
        $this->cmd(10);
        $content = $this->header();
        $data = $this->socket($content, true);
        $data = $this->getData($data, TRUE);
        //$len = $this->dataSize($data);
        $type = 'n';
        $format = "/{$type}Type/{$type}Status/NSize/a30Time/a260Path";
        $size = 300;
        $arr = array();
        $where = '0';
        while ($where !== false) {
            $arrList = @unpack("@$where$format", $data);
            if (!$arrList) {
                break;
            }
            $arr[] = $arrList;
            $where+=$size;
        }
        return $arr;
    }

	function payAccountCheck1(){
		$this->cmd(34);
		$this->postOutTime = 1;
		
		$size = 320;
		$content = $this->header($size);
		//echo $username;
		//exit;
		$content .= pack('a32'," ");
		$content .= pack('a32','0');
		$content .= pack('a256'," ");

		$result = $this->socket($content,true);

		$result = $this->getData($result,true);
		
		$resultArr = unpack('nVipScore/aPlatform/aVipLevel/ILeftHours/a120Reserve',$result);

		$resultArr['LeftHours'] = $this->ntohl($resultArr['LeftHours']);
		
		return $resultArr;
	}
	
	function payAccountCheck(){
		$this->cmd(34);
		$this->postOutTime = 1;
	
		$size = 320;
		$content = $this->header($size);
		//echo $username;
		//exit;
		$content .= pack('a32'," ");
		$content .= pack('a32','0');
		$content .= pack('a256'," ");
	
		$result = $this->socket($content,true);
		$result = $this->getData($result,true);
		
		$dataArr = array();
		//echo strlen($result);
		//exit;
		
		$size = 256;
		$struct1 = substr($result, 0, $size);
		$data1 = unpack("nStructCount/a254Reserve", $struct1);
		$tmpData = array();
		
		$returnArr = array();
		
		for($i=0; $i<trim($data1['StructCount']); $i++){
			$struct2 = substr($result,$size+128*$i,128);
			$tmpData = unpack("nVipScore/c1Platform/c1VipLevel/ILeftHours/a120Reserve",$struct2);
			$tmpData['LeftHours'] = $this->ntohl($tmpData['LeftHours']);
			
			array_push($returnArr, $tmpData);
		}
		
		return $returnArr;
		
		/*
		$size = 128;
		$struct2 = substr($result,256,$size);
		
		$data1 = unpack("nVipScore/c1Platform/c1VipLevel/ILeftHours/a120Reserve",$struct2);
		$data1['LeftHours'] = $this->ntohl($data1['LeftHours']);
		
		return $data1;*/
	}
    
    function returnType($type) {
        $this->debug($type);
        if ($type === true || $type == '0') {
            return $type;
        } elseif (is_array($type)) {
            return $type['te xt'];
        } else {
            return false;
        }
    }

    private function getData($data, $return = false) {
        $this->debug('收到的数据长度：' . strlen($data) . '-----' . $data);
        $len = $this->headerSize;
        $str = substr($data, $len);
        if ($return) {
            return $str;
        }
        if ($str) {
            $arr = unpack('N', $str);
            return base_convert($arr[1], 10, 16);
        }
        return false;
    }

    private function socketChar($str) {
        $str = pack("a32", $str);
        return $str;
    }

    private function debug($str) {
        $text = "Attempting to connect to '$this->host' on port '$this->port'...<br/>";
        $text .=$str;
        if ($this->debug) {
            var_dump($text);
        }
        return;
    }

    private function getPassWord($password) {
        $password = trim($password);
        $salt = '$1$xcloud$';
        $password = crypt($password, $salt);
        $password = str_replace($salt, '', $password);
        return $password;
    }

}

?>