#!/bin/sh
#***********************************************
# File Name  : xCloudSynologyClient.sh
# Description: xCloudSynologyClient operate
# Make By    :lqf
# Date Time  :2012/08/15
#***********************************************
UsAge="UsAge: $0 {start|stop|restart}"
module_name='xCloud'
XSCPATH="/usr/local/AppCentral/$module_name/"
XSCPATH_BIN=$XSCPATH"bin/"
PRONAME="xCloudClient"
RTNFILE=".xCloudLogInRtn"
UPDATASH="update.sh"
UPDATAPID=".updatapid"
MONITORPID=".monitorpid"
MONITORXCLOUD=".monitorxcloud"
PIDFILEPATH=".pid"
VERSIONFILE=".version"
PID=$$
share_path="/volume1"

KILL=/bin/kill
ECHO=/bin/echo
CAT=/bin/cat

StartSV()
{
    $ECHO "Starting xCloudClient."

    chmod 755 $XSCPATH_BIN$PRONAME
    $XSCPATH_BIN$PRONAME > /dev/null 2>&1 &

    #chmod 755 $XSCPATH$UPDATASH
    #$XSCPATH$UPDATASH >/dev/null 2>&1 &
    
    $XSCPATH"monitor.sh" > /dev/null 2>&1 &
    $XSCPATH"restart_xcloud.sh" > /dev/null 2>&1 &
}

StopSV()
{
    STOPFILE=$XSCPATH_BIN".T3vkFOL4DVQo2wrC4DQG0"
    $ECHO "Stoping xCloudClient"
    echo "Stoping xCloudSynologyClient" > $STOPFILE
    sleep 3

    if [ -f "$XSCPATH$UPDATAPID" ]
    then
        $KILL -9 `$CAT $XSCPATH$UPDATAPID` > /dev/null 2>&1
    fi

    if [ -f "$XSCPATH$MONITORPID" ]
    then
        $KILL -9 `$CAT $XSCPATH$MONITORPID` > /dev/null 2>&1
    fi

    if [ -f "$XSCPATH$MONITORXCLOUD" ]
    then
        $KILL -9 `$CAT $XSCPATH$MONITORXCLOUD` > /dev/null 2>&1
    fi

    if [ -f "$XSCPATH_BIN$PIDFILEPATH" ]
    then
        $KILL -9 `$CAT $XSCPATH_BIN$PIDFILEPATH` > /dev/null 2>&1
    fi

    if [ -f "$STOPFILE" ]
    then
        rm -rf $STOPFILE
    fi

    if [ -f "$XSCPATH$RTNFILE" ]
    then
        rm -rf $XSCPATH$RTNFILE
    fi

    if [ -f "$XSCPATH_BIN$PIDFILEPATH" ]
    then
        rm -rf $XSCPATH_BIN$PIDFILEPATH
    fi

    if [ -f "$XSCPATH$UPDATAPID" ]
    then
        rm -rf $XSCPATH$UPDATAPID
    fi

    if [ -f "$XSCPATH$MONITORPID" ]
    then
        rm -rf $XSCPATH$MONITORPID
    fi

    if [ -f "$XSCPATH$MONITORXCLOUD" ]
    then
        rm -rf $XSCPATH$MONITORXCLOUD
    fi

    if [ -f "$XSCPATH_BIN$VERSIONFILE" ]
    then
        rm -rf $XSCPATH_BIN$VERSIONFILE
    fi
}

ReStartSV()
{
    $ECHO "ReStarting xCloudSynologyClient"

    StopSV
    StartSV
}

case "$1" in
    start)
        StartSV
        exit 0
        ;;
    stop)
        StopSV
        exit 0
        ;;
    restart)
        ReStartSV
        exit 0
        ;;
    *)
        echo $UsAge
        exit 1;
        ;;
esac

exit 0
